#include <iostream>
using namespace std;

/**
 * @brief Findet die nächste leere Zelle in einem Sudoku-Raster.
 *
 * Diese Funktion durchsucht das bereitgestellte Sudoku-Raster nach der nächsten Zelle, die leer ist (enthält eine 0).
 * Wenn eine leere Zelle gefunden wird, setzt die Funktion die Zeilen- und Spaltenindizes auf die Position dieser Zelle.
 *
 * @param feld Ein Zeiger auf ein 9x9 Sudoku-Raster.
 * @param row Ein Zeiger auf eine Ganzzahl, in der der Zeilenindex der nächsten leeren Zelle gespeichert wird.
 * @param col Ein Zeiger auf eine Ganzzahl, in der der Spaltenindex der nächsten leeren Zelle gespeichert wird.
 * @return `true`, wenn eine leere Zelle gefunden wird, `false`, wenn das Raster vollständig gefüllt ist.
 */
bool naechsterZelle(int (*feld)[9][9], int* row, int* col) {
  // TODO a)
  return false; // Platzhalter
}

/**
 * @brief Überprüft, ob eine Zahl in einem bestimmten Feld eines Sudoku-Rätsels eingetragen werden kann.
 *
 * Diese Funktion überprüft, ob die gegebene Zahl `num` in das Feld an der Position `(row, col)` 
 * des Sudoku-Rätsels `feld` eingefügt werden kann, ohne die Sudoku-Regeln zu verletzen.
 *
 * @param feld Ein Zeiger auf ein 9x9 Sudoku-Raster.
 * @param row Die Zeile des Feldes, das überprüft werden soll.
 * @param col Die Spalte des Feldes, das überprüft werden soll.
 * @param num Die Zahl, die in das Feld eingefügt werden soll.
 * @return `true`, wenn die Zahl in das Feld eingefügt werden kann, andernfalls `false`.
 */
bool darfEintragen(int (*feld)[9][9], int row, int col, int num) {
  // TODO b)
  return false; // Platzhalter
}

/**
 * @brief Löst ein gegebenes Sudoku-Puzzle rekursiv.
 *
 * Diese Funktion versucht, ein gegebenes Sudoku-Puzzle zu lösen, indem sie
 * rekursiv Zahlen in leere Zellen einträgt und überprüft, ob die Platzierung
 * gültig ist. Wenn eine gültige Lösung gefunden wird, wird true zurückgegeben.
 * Andernfalls wird false zurückgegeben.
 *
 * @param feld Ein Zeiger auf ein 9x9 Sudoku-Raster. Leere Zellen
 *             sind mit 0 markiert.
 * @return `true`, wenn das Sudoku gelöst werden kann, andernfalls `false`.
 */
bool loeseSudoku(int (*feld)[9][9]) {
  // TODO c)
  return false; // Platzhalter
}

/**
 * @brief Zeigt ein Sudoku-Raster an.
 *
 * Diese Funktion druckt ein 9x9 Sudoku-Raster auf die Standardausgabe. Jede Zelle
 * wird durch ein Leerzeichen getrennt, und das Raster wird durch vertikale und
 * horizontale Linien in 3x3 Unterraster unterteilt.
 *
 * @param feld Ein Zeiger auf ein 9x9 Array, das das Sudoku-Raster darstellt. Jedes
 *             Element sollte eine Ganzzahl zwischen 1 und 9 sein. Zellen mit Werten
 *             außerhalb dieses Bereichs werden als '.' angezeigt.
 */
void zeigeSudoku(int (*feld)[9][9]) {
  for (int i = 0; i < 9; ++i) {
    for (int j = 0; j < 9; ++j) {
      std::cout << (char)((*feld)[i][j]<=9 && (*feld)[i][j]>=1 ? (*feld)[i][j]+'0' : '.') << " ";
      if ((j + 1) % 3 == 0 && j != 8)
        std::cout << "| ";
    }
    std::cout << endl;
    if ((i + 1) % 3 == 0 && i != 8) {
      for (int k = 0; k < 21; ++k) {
        std::cout << "-";
      }
      std::cout << endl;
    }
  }
}

int main() {
  int feld[9][9] = {
    {4, 0, 0,   0, 0, 5,   0, 8, 0},
    {0, 1, 0,   0, 0, 0,   0, 0, 0},
    {7, 0, 3,   4, 2, 0,   0, 0, 0},

    {0, 0, 0,   0, 0, 0,   1, 0, 0},
    {0, 0, 9,   1, 0, 0,   0, 0, 7},
    {5, 3, 0,   2, 0, 0,   0, 9, 0},

    {0, 0, 0,   0, 0, 0,   7, 0, 8},
    {0, 0, 5,   0, 0, 6,   0, 0, 0},
    {0, 0, 0,   0, 9, 0,   0, 5, 0}
  };
  cout << "Sudoku-Rätsel:" << endl;
  zeigeSudoku(&feld);

  if (loeseSudoku(&feld)) {
    std::cout << endl << "Lösung:" << std::endl;
    zeigeSudoku(&feld);
    return 0;
  } else {
    std::cout << "Keine Lösung gefunden." << std::endl;
    return 1;
  }
}